package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.Table;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.badlogic.gdx.utils.Align;
import com.badlogic.gdx.utils.Array;

import zero1hd.rhythmbullet.controls.KeyMap;

public class ControlOptions extends Table {
	public ControlOptions(Skin skin, KeyMap keyMap) {
		super(skin);
		align(Align.center);
		
		//first
		Label forwardKeyLabel = new Label("Forward: ",skin);
		forwardKeyLabel.setName(KeyMap.UP);
		add(forwardKeyLabel).left();
		KeyBindButton forwardKeySetter = new KeyBindButton(keyMap, KeyMap.UP);
		add(forwardKeySetter).spaceRight(45f);
		Label shootKeyLabel = new Label("Shoot: ", skin);
		shootKeyLabel.setName(KeyMap.SHOOT);
		add(shootKeyLabel).left();
		KeyBindButton shootKeySetter = new KeyBindButton(keyMap, KeyMap.SHOOT);
		add(shootKeySetter);
		
		row();

		//second
		Label backwardKeyLabel = new Label("Backward: ", skin);
		backwardKeyLabel.setName(KeyMap.DOWN);
		add(backwardKeyLabel).left();
		KeyBindButton backwardKeySetter = new KeyBindButton(keyMap, KeyMap.DOWN);
		add(backwardKeySetter).spaceRight(45f);
		Label sector1TPKeyLabel = new Label("Left Teleport", skin);
		sector1TPKeyLabel.setName(KeyMap.FIRSTTHIRDTELEPORT);
		add(sector1TPKeyLabel).left();
		KeyBindButton Sector1TPKeySetter = new KeyBindButton(keyMap, KeyMap.FIRSTTHIRDTELEPORT);
		add(Sector1TPKeySetter);
		
		row();
		
		Label leftKeyLabel = new Label("Left: ", skin);
		leftKeyLabel.setName(KeyMap.LEFT);
		add(leftKeyLabel).left();
		KeyBindButton leftKeySetter = new KeyBindButton(keyMap, KeyMap.LEFT);
		add(leftKeySetter).spaceRight(45f);
		Label sector2TPKeyLabel = new Label("Middle Teleport: ", skin);
		sector2TPKeyLabel.setName(KeyMap.SECONDTHIRDTELEPORT);
		add(sector2TPKeyLabel).left();
		KeyBindButton sector2TPKeySetter = new KeyBindButton(keyMap, KeyMap.SECONDTHIRDTELEPORT);
		add(sector2TPKeySetter);
		
		row();
		
		Label rightKeyLabel = new Label("Right: ", skin);
		rightKeyLabel.setName(KeyMap.RIGHT);
		add(rightKeyLabel).left();
		KeyBindButton rightKeySetter = new KeyBindButton(keyMap, KeyMap.RIGHT);
		add(rightKeySetter).spaceRight(45f);
		Label sector3TPKeyLabel = new Label("Right Teleport: ", skin);
		sector3TPKeyLabel.setName(KeyMap.THIRDTHIRDTELEPORT);
		add(sector3TPKeyLabel).left();
		KeyBindButton sector3TPKeySetter = new KeyBindButton(keyMap, KeyMap.THIRDTHIRDTELEPORT);
		add(sector3TPKeySetter);
		
		addListener(new ClickListener() {
			@Override
			public void clicked(InputEvent event, float x, float y) {
				unselect();
				getStage().setKeyboardFocus(event.getTarget());
				event.getTarget().setColor(Color.ORANGE);
				super.clicked(event, x, y);
			}
		});
		
		setFillParent(true);
	}
	
	public void unselect() {
		Array<Actor> keys = getChildren();
		for (int i = 0; i < keys.size; i++) {
			keys.get(i).setColor(Color.WHITE);;
		}
	}
	
	@Override
	public void act(float delta) {
		super.act(delta);
	}
}
