package zero1hd.rhythmbullet.graphics.ui.pages;

import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.Pixmap.Format;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.ScrollPane;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;

import zero1hd.rhythmbullet.graphics.ui.components.GraphicsOptions;

public class VideoOptionsPage extends Page {
	private ScrollPane scrollPane;
	private GraphicsOptions graphicsTable;
	public VideoOptionsPage(Skin skin, Preferences prefs) {
		graphicsTable = new GraphicsOptions(skin, prefs);
		graphicsTable.clear();
		Pixmap pix = new Pixmap(4, 4, Format.RGBA8888);
		pix.setColor(Color.WHITE);
		pix.fill();
		Texture texture = new Texture(pix);
		Image image = new Image(texture);
		graphicsTable.add(image).minHeight(4000).minWidth(2000);
		scrollPane = new ScrollPane(graphicsTable, skin);
		scrollPane.setFadeScrollBars(false);
		scrollPane.setFillParent(true);
		addActor(scrollPane);
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		super.draw(batch, parentAlpha);
	}
	
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	public void save() {
		graphicsTable.save();
	}
}
